 type
  xmsMovePtr=^xmsMoveStructure;
  xmsMoveStructure=record
   length:longint;
   sourceHandle:word; sourceOffset:longint;
   destHandle:word; destOffset:longint;
  end;

 var XmsError:integer;
 var XmsPresent_:boolean;
 var XmsControl:pointer; XmsControl_Seg,XmsControl_Ofs:word;
 var XMS_ver, HIMEM_ver:word; hmaPresent:boolean;
 var Largest,Total:word;
 var sizeInK:word; freeHandles,LockCount:byte;
 var A20enabled:boolean;

 var ax,dx,si:word; al,bl,bh,dl:byte; {opis. v gol. prog.; ss: -> shuin}

 const s012:array[0..15] of char='0123456789ABCDEF';
 function hexb(a:byte):string; var i1,i2:integer;
 begin i1:=a mod 16; i2:=a div 16; hexb:=s012[i2]+s012[i1]; end;
 function hex(a:word):string; var i1,i2,i3,i4:integer;
 begin
  i1:=a mod 16; a:=a div 16;
  i2:=a mod 16; a:=a div 16;
  i3:=a mod 16; i4:=a div 16;
  hex:=s012[i4]+s012[i3]+s012[i2]+s012[i1];
 end;

 function XmsPresent:boolean; var r:registers;
 begin
  r.ax:=$4300; intr($2F,r);
  if r.al<>$80 then begin
   writeln('XmsPresent: r.al=',r.al:5);
   XmsError:=1; XmsPresent:=false; exit;
  end;
  r.ax:=$4310; intr($2F,r);
  XmsControl:=Ptr(r.es,r.bx); XmsControl_Seg:=r.es; XmsControl_Ofs:=r.bx;
  XmsError:=0; XmsPresent:=true;
 end;

 procedure XmsVersion;
 begin
  if XmsControl=nil then exit;
  inline($B8/$00/$00/$FF/$1E/>XmsControl); {ax=0, kosv. vyzov XmsControl}
  inline($A3/>XMS_ver/$89/$1E/>HIMEM_ver); {zapomin. ax i bx}
  inline($88/$16/>hmaPresent); {hmaPresent=dl}
 end;

 procedure XmsRequestHMA(Space:word); {ne ispol`z.}
 begin
  if XmsControl=nil then exit;
  dx:=space;
  inline($B4/$01/$8B/$16/>dx); {ah=1, dx=space}
  inline($FF/$1E/>XmsControl); {kosv. vyzov XmsControl}
  inline($A3/>ax/$88/$1E/>bl); {ax i bl - iz reg-rov}
  writeln('XmsRequestHMA: ax,bl=',hex(ax),' ',hexb(bl));
  if ax=0 then XmsError:=($00FF and bl) else XmsError:=0;
 end;

 procedure XmsReleaseHMA; {ne ispol`z.}
 begin
  if XmsControl=nil then exit;
  inline($B4/$02); {ah=2}
  inline($FF/$1E/>XmsControl); {kosv. vyzov XmsControl}
  inline($A3/>ax/$88/$1E/>bl); {ax i bl - iz reg-rov}
  writeln('XmsReleaseHMA: ax,bl=',hex(ax),' ',hexb(bl));
  if ax=0 then XmsError:=($00FF and bl) else XmsError:=0;
 end;

 procedure queryA20;
 begin
  inline($B4/$07); {ah=7}
  inline($FF/$1E/>XmsControl); {kosv. vyzov XmsControl}
  inline($A2/>al/$88/$1E/>bl); {al, bl - iz reg-rov}
  {writeln('queryA20: al,bl=',hexb(al),' ',hexb(bl));}
  if bl<>0 then begin XmsError:=bl; exit; end;
  XmsError:=0; A20enabled:=(al=1);
 end;

 procedure queryFreeExtendedMemory; {-> v Kb}
 begin
  if XmsControl=nil then exit;
  inline($B4/$08); {ah=8}
  inline($FF/$1E/>XmsControl); {kosv. vyzov XmsControl}
  inline($A3/>ax/$89/$16/>dx/$88/$1E/>bl); {ax, dx, bl - iz reg-rov}
  {writeln('queryFreeExtendedMemory: ax,dx,bl=',
    hex(ax),' ',hex(dx),' ',hexb(bl));}
  if bl<>0 then begin XmsError:=bl; Largest:=0; Total:=0; exit; end;
  XmsError:=0; Largest:=ax; Total:=dx;
 end;

 procedure allocateXMB(Kb:word; var handle:word);
 begin
  if XmsControl=nil then exit;
  dx:=Kb;
  inline($B4/$09/$8B/$16/>dx); {ah=9, dx=razmer v Kb}
  inline($FF/$1E/>XmsControl); {kosv. vyzov XmsControl}
  inline($A2/>al/$89/$16/>dx/$88/$1E/>bl); {al, dx, bl - iz reg-rov}
  {al - vydeleno, bl - XmsError, dx - handle}
  {writeln('allocateXMB: al,dx,bl=',hexb(al),' ',hex(dx),' ',hexb(bl));}
  if bl<>0 then begin
   XmsError:=bl; writeln('allocateXMB: bl=',hexb(bl)); halt;
  end;
  XmsError:=0; handle:=dx;
 end;

 procedure freeXMB(handle:word);
 begin
  if XmsControl=nil then exit;
  dx:=handle;
  inline($B4/$0A/$8B/$16/>dx); {ah=$0A, dx=handle}
  inline($FF/$1E/>XmsControl); {kosv. vyzov XmsControl}
  inline($A2/>al/$88/$1E/>bl); {al, dx, bl - iz reg-rov}
  {writeln('freeXMB: al,bl=',hexb(al),' ',hexb(bl));}
  if bl<>0 then begin XmsError:=bl; exit; end;
  XmsError:=0;
 end;

procedure moveXMB(structure:xmsMovePtr);
begin
 ax:=seg(structure^); si:=ofs(structure^);
 inline($1E/$07); {push ds/pop es}
 inline($8B/$36/>si/$A1/>ax);
 inline($8E/$D8); {ds:=ax}
 inline($B4/$0B); {ah=$0B}
 inline($26/$FF/$1E/>XmsControl); {kosv. vyzov XmsControl s es:}
 inline($06/$1F); {push es/pop ds}
 inline($A2/>al/$88/$1E/>bl);
 {v norme -> al=1, bl - razn., obychno <80; smysl nejasen; vylez. -> 0 i A7}
 if not ((al=1) {and (bl<=$80)}) then begin
  writeln('moveXMB: al,bl=',hexb(al),' ',hexb(bl)); 
  with structure^ do writeln(length,'  ',
    sourceHandle,':',sourceOffset,' ',destHandle,':',destOffset);
  halt;
 end;
end;
procedure moveXMBlock(len:longint; srcHandle:word; srcOfs:longint;
                     dstHandle:word; dstOfs:longint);
 var struct:xmsMoveStructure;
begin
 with struct do begin
  length:=len;
  sourceHandle:=srcHandle; sourceOffset:=srcOfs;
  destHandle:=dstHandle; destOffset:=dstOfs;
 end;
 moveXMB(@struct);
end;
procedure MainToXMB(len:word; fromPtr:pointer; toHandle:word; toOfs:longint);
 var l:longint;
begin
 l:=longint(fromPtr); moveXMBlock(len,0,l,toHandle,toOfs);
end;
procedure XMBToMain(len:word; toPtr:pointer; fmHandle:word; fmOfs:longint);
 var l:longint; fict:boolean;
begin
 l:=longint(toPtr); moveXMBlock(len,fmHandle,fmOfs,0,l);
end;

 procedure getXMBInformation(handle:word);
 begin
  dx:=handle;
  inline($B4/$0E/$8B/$16/>dx); {ah=$0E, dx=handle}
  inline($FF/$1E/>XmsControl); {kosv. vyzov XmsControl}
  inline($A2/>al/$89/$16/>dx/$88/$1E/>bl/$88/$3E/>bh);
  XMSError:=al; LockCount:=bh; FreeHandles:=bl; SizeInK:=dx;
 end;

 procedure show;
 begin
  queryFreeExtendedMemory;
  writeln('Total,Largest (v Kb) = ',Total:6,Largest:6);
 end;
 procedure stat(blockHandle:word);
 begin
  getXMBInformation(blockHandle);
  write('handle=',blockHandle,'; lock count=',LockCount,
    '; size in K= ',SizeInK);
  writeln('; free handles=',FreeHandles);
 end;

